﻿using EV3ModelLib;
using EV3TreeVisLib.Logic.Converter;
using Medallion.Collections;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Xml.Linq;

namespace EV3TreeVisLib.Logic
{
    /// <summary>
    /// Logical Block representing one EV3 node
    /// </summary>
    [DebuggerDisplay("#{Id} {Block}")]
    public class LogBlock
    {
        public LogBlock(XElement elem_in)
        {
            Params = new NodeParams(this);
            this.Element = elem_in;
        }

        /// <summary>
        /// Extra Block names - generated by the node list generator
        /// </summary>
        public static class ExtraBlocks
        {
            public const string COMMENTBOX = "CommentBox";
            public const string CONNECTOR = Node.BLOCK_CONNECTOR;
            public const string FORK = Node.BLOCK_Fork;
            public const string FORKITEM = Node.BLOCK_ForkItem;
            public const string CASEITEM = Node.BLOCK_SwitchCaseItem;
            public const string STARTBLOCK = Node.BLOCK_StartBlock;
            public const string EMPTY = Node.BLOCK_Empty;
            public const string ROOT_ID = Node.BLOCK_Root;
            public const string TOP_ID = Node.BLOCK_TopID;
            public const string PROJECT_IMAGES = "(Images)";
            public const string PROJECT_SOUNDS = "(Sounds)";
            public const string PROJECT_VARS = "(Variables)";
            public const string PROJECT_WARNINGS = "(Warnings)";
        }
        public const string CONST_ATTR_USEDBY = "usedBy";

        /// <summary>
        /// Block types - generated or Natvive from ev3p file
        /// </summary>
        public enum BlockTypes
        {
            NativeSwitch = 0, NativeWait = 1, NativeEV3P = 2, Native,
            // not native nodes - must be after "Native"
            Root = 10, /*Top = 11,*/ ForkParent = 12, ForkItem = 13, CaseItem = 14, Connector = 15,
            Empty = 20,
            ProjectRoot = 21,
            ProjectExtraImages = 22, ProjectExtraSounds = 23, ProjectExtraVariables = 24, ProjectExtraWarnings = 25
        }

        /// <summary>
        /// Is myBlock property
        /// </summary>
        public bool IsMyBlock { get; internal set; }
        //public string MyBlockIcon { get; internal set; }

        /// <summary>
        /// is this block a native block?
        /// </summary>
        [JsonIgnore]
        public bool IsBlockTypeNative
        {
            get
            {
                return this.BlockType <= BlockTypes.Native;
            }
        }

        /// <summary>
        /// Block name as string
        /// </summary>
        [JsonProperty("name")]
        public string Block { get; set; }

        /// <summary>
        /// Block Id
        /// </summary>
        [JsonIgnore]
        public string Id { get; set; }

        /// <summary>
        /// Block type
        /// </summary>
        [JsonProperty("type")]
        public BlockTypes BlockType { get; set; } = BlockTypes.Native;

        /// <summary>
        /// Parameters and wires
        /// </summary>
        public NodeParams Params { get; }

        /// <summary>
        /// Children of the node 
        /// </summary>
        [JsonProperty("children")]
        public List<LogBlock> Children;

        /// <summary>
        /// Sequence wire incoming
        /// </summary>
        [JsonIgnore]
        public string WireIn { get; set; }

        /// <summary>
        /// Parent of the node
        /// </summary>
        [JsonIgnore]
        public LogBlock Parent { get; set; }

        // only add for JSON generation //TODO: use decorator
        public Dictionary<string, string> Display;

        /// <summary>
        /// Details for displaying the block display
        /// </summary>
        [JsonIgnore]
        public BlockNameConverter.LegoBlockRecord BlockDisplayDetails;

        /// <summary>
        /// Full id with name and scope
        /// </summary>
        [JsonIgnore]
        public string FullId
        {
            get
            {
                return Scope + (Id != null ? "." + Id : null);
            }
        }

        /// <summary>
        /// Scope of the node (previous nodes as path)
        /// </summary>
        [JsonIgnore]
        public string Scope
        {
            get
            {
                if (Parent == null) return ExtraBlocks.TOP_ID;
                if (Parent.Parent != null)
                {
                    if (Parent.Block == Node.BLOCK_StartBlock) return Parent.Scope; //repeated Start Blocks, in case of multiple start blocks - should flatten scope (e.g. for myblock inputs)
                    else return Parent.FullId;
                }
                //-- should not be the case and also seems erroneous - left here for compatibility/historical reason //TODO: check
                else return ExtraBlocks.TOP_ID + "." + Parent.Id;
            }
        }

        /// <summary>
        /// returns all childrens
        /// </summary>
        /// <returns></returns>
        public int ChildrenCount(bool bIncludeAllLevels)
        {
            return
                (bIncludeAllLevels ?
                    Children?.Sum(elem => elem.ChildrenCount(bIncludeAllLevels)) ?? 0 :
                    Children?.Count ?? 0
                ) +
                1;
        }

        /// <summary>
        /// Return all children in any depths
        /// </summary>
        /// <returns></returns>
        public List<LogBlock> ChildrenTraversed()
        {
            return Traverse.DepthFirst(this, elem => elem?.Children ?? Enumerable.Empty<LogBlock>()).ToList();
        }

        [JsonIgnore]
        public XElement Element { get; set; }

        /// <summary>
        /// Return color for the block
        /// </summary>
        /// <returns></returns>
        public string GetColor()
        {
            if (BlockType == LogBlock.BlockTypes.ProjectRoot) return "magenta";
            if (BlockDisplayDetails != null) return BlockNameConverter.GetColorForFamily(BlockDisplayDetails.BlockFamily);
            return null;
        }

        /// <summary>
        /// Static ctor to register converter
        /// </summary>
        static LogBlock()
        {
            LogBlock2ModelConverter.RegisterConverter();
        }
    }
}
